; na adr. 96 je prenaseny byte prijaty seriove
; na adr. 95 je priznak, zda bylo vubec neco projato
; na adr. 94 je status jestli posilat klavesy nebo bmnetem
; kdyz prijde 0xf0, tak nsledujc byte m tyto mon vznamy:
; 	01 ... pepni na emulaci klves
;	02 ... pepni na bmnet
;	03 nebo vc ... poli znak 0xf0


.org 	0
	ljmp init		; skok na start programu
.org	3
	reti
.org    11                      ; obsluha casovace 0 - pro operace bmnetu
        reti
.org	19
	reti
.org	27
	reti
.org	35
	ljmp serial		; skok na obsluhu preruseni od serioveho prenosu


init:	mov r3,#0
	mov sp,#48		; nastav zasobnik


init1:	clr tr1			; zastav casovac
	mov th1,#0xf4 	; oboji f4=4800bps pro krystal 22.1184 MHz
	mov tl1,#0xf4		; stejne jako predchozi
        mov tmod,#0x20 	; bylo 22          ; nastav casovac 1 na mod 2, casovac 0 na mod 2
                                ; casovac1 pro serial, casovac0 pro hodiny.
	mov scon,#0x52		; nastav 8bit uart
	setb tr1		; spust casovac 1 pro serial
	clr ti			; smazani priznaku preruseni odesilani
	clr ri			; a prijmu - dulezite, protoze po resetu je nastaven
      	mov ie,#0x90 ; bylo 92            ; povol preruseni serioveho kanalu a masku a casovace 0
                                ; ie=#0x8a v bmnetu a #0x90 v seriovem


start:	mov 0xb0,#0xff		; nastavi branu p3 na vstupni
	mov 0x90,#0xff		; nastavi branu p1 na vstupni
	mov 95,#0
	mov r0,#0		; cekaci smycka 5 vterin
	mov r1,#0		; 
	mov r2,#10		; 
	mov 94,#1		; po startu je zapnuta emulace klves
	setb p2.0
	setb p2.1
	setb p2.2
	setb p2.3
	setb p2.4
	setb p2.5
	setb p2.6
	setb p2.7
start1:	djnz r0,start1		
	djnz r1,start1
      cpl p3.2
	djnz r2,start1


main:	jnb p2.2,mainw4		; kdy je p2.2 v nule (pc4), probiha v planu zmena 8255ky
	mov r5,#150
mainw5:	jb p2.1,mainw4		; kdy neni p2.1 v nule, plan nic neposila
      djnz r5,mainw5
	mov a,94
	cjne a,#2,mainw4
	lcall bmin
mainw4:	mov a,95
	cjne a,#1,main
	mov 95,#0
	mov a,96
	cjne a,#240,main0	; kdyz to neni ridici byte, tak dl

mainw1:	mov a,95		; prisel priznak, cekej na dalsi urcujici byte
	cjne a,#1,mainw1
	mov 95,#0
	mov a,96
	cjne a,#1,mainw2	; kdyz to neni status 1
	mov 94,#1		; prepni na emulaci klaves
	clr p3.2		; rozne ledku
	ajmp main
mainw2:	cjne a,#2,mainw3	; kdyz do nen ani 2
	mov 94,#2		; prepni na bmnet
	setb p3.2		; zhasne ledku
	ajmp main
mainw3: mov a,#240		; zpracuj znak 0xf0
	mov 96,#240

main0:	mov r1,94		; nacti rezim emulace
	cjne r1,#2,main00	; neni to bmnet, skok na mackani klaves

	push 2			; vysilej bmnetem prijate z PC
	mov r3,a		; vysilany byte do r3
	push 3
	cpl p3.2
	mov r2,#8		; rutina odeslani bytu v r3 , r2 je ta bit
out1: jb p2.2,out1		; ekm, a bude p2.2 nulov
	mov a,r3
	rlc a                   ; prenos bitu do Carry
	mov r3,a
        mov p2.0,C              ; prenos bitu z c na data
        clr p2.1                ; nastaveni handshake na 0
out2:	jnb p2.2,out2		; ekm, a bude p2.2 v jednice
	setb p2.1
	djnz r2,out1 		; odeslani dalsiho bitu
	pop 3
	pop 2
	mov a,r3		; odeslat prijaty znak seriove jako potvrzeni dokonceni prenosu
	mov sbuf,a		; odeslani bytu
out3:	jnb ti,out3
	clr ti
	setb p2.0
	ajmp main

main00:	mov a,96
	cjne a,#10,main1
	lcall klen
main1:	cjne a,#32,main2
	lcall klsp
main2:	cjne a,#65,main3
	lcall kla
main3:	cjne a,#66,main4
	lcall klb
main4:	cjne a,#67,main5
	lcall klc
main5:	cjne a,#68,main6
	lcall kld
main6:	cjne a,#69,main7
	lcall kle
main7:	cjne a,#70,main8
	lcall klf
main8:	cjne a,#71,main9
	lcall klg
main9:	cjne a,#72,main10
	lcall klh
main10:	cjne a,#73,main11
	lcall kli
main11:	cjne a,#74,main12
	lcall klj
main12:	cjne a,#75,main13
	lcall klk
main13:	cjne a,#76,main14
	lcall kll
main14:	cjne a,#77,main15
	lcall klm
main15:	cjne a,#78,main16
	lcall kln
main16:	cjne a,#79,main17
	lcall klo
main17:	cjne a,#80,main18
	lcall klp
main18:	cjne a,#81,main19
	lcall klq
main19:	cjne a,#82,main20
	lcall klr
main20:	cjne a,#83,main21
	lcall kls
main21:	cjne a,#84,main22
	lcall klt
main22:	cjne a,#85,main23
	lcall klu
main23:	cjne a,#86,main24
	lcall klv
main24:	cjne a,#87,main25
	lcall klw
main25:	cjne a,#88,main26
	lcall klx
main26:	cjne a,#89,main27
	lcall kly
main27:	cjne a,#90,main28
	lcall klz
main28:	cjne a,#48,main29
	lcall kl0
main29:	cjne a,#49,main30
	lcall kl1
main30:	cjne a,#50,main31
	lcall kl2
main31:	cjne a,#51,main32
	lcall kl3
main32:	cjne a,#52,main33
	lcall kl4
main33:	cjne a,#53,main34
	lcall kl5
main34:	cjne a,#54,main35
	lcall kl6
main35:	cjne a,#55,main36
	lcall kl7
main36:	cjne a,#56,main37
	lcall kl8
main37:	cjne a,#57,main38
	lcall kl9
main38: cjne a,#33,main39
	lcall klvy
main39: cjne a,#34,main40
	lcall kluv
main40: cjne a,#35,main41
	lcall klkr
main41: cjne a,#36,main42
	lcall kldo
main42: cjne a,#37,main43
	lcall klpr
main43: cjne a,#38,main44
	lcall klam
main44: cjne a,#39,main45
	lcall klap
main45: cjne a,#40,main46
	lcall klkzr
main46: cjne a,#41,main47
	lcall klkzl
main47: cjne a,#42,main48
	lcall klhv
main48: cjne a,#43,main49
	lcall klpl
main49: cjne a,#44,main50
	lcall klca
main50: cjne a,#45,main51
	lcall klmi
main51: cjne a,#46,main52
	lcall klte
main52: cjne a,#47,main53
	lcall kllo
main53: cjne a,#58,main54
	lcall kldt
main54: cjne a,#59,main55
	lcall klsc
main55: cjne a,#60,main56
	lcall klme
main56: cjne a,#61,main57
	lcall klro
main57: cjne a,#62,main58
	lcall klve
main58: cjne a,#63,main59
	lcall klot
main59: cjne a,#64,main60
	lcall klza
main60: cjne a,#91,main61
	lcall klhzr
main61: cjne a,#93,main62
	lcall klhzl
main62: cjne a,#94,main63
	lcall klst
main63: cjne a,#95,main72
	lcall klpo

main72:	cjne a,#97,main73
	lcall kla
main73:	cjne a,#98,main74
	lcall klb
main74:	cjne a,#99,main75
	lcall klc
main75:	cjne a,#100,main76
	lcall kld
main76:	cjne a,#101,main77
	lcall kle
main77:	cjne a,#102,main78
	lcall klf
main78:	cjne a,#103,main79
	lcall klg
main79:	cjne a,#104,main80
	lcall klh
main80:	cjne a,#105,main81
	lcall kli
main81:	cjne a,#106,main82
	lcall klj
main82:	cjne a,#107,main83
	lcall klk
main83:	cjne a,#108,main84
	lcall kll
main84:	cjne a,#109,main85
	lcall klm
main85:	cjne a,#110,main86
	lcall kln
main86:	cjne a,#111,main87
	lcall klo
main87:	cjne a,#112,main88
	lcall klp
main88:	cjne a,#113,main89
	lcall klq
main89:	cjne a,#114,main90
	lcall klr
main90:	cjne a,#115,main91
	lcall kls
main91:	cjne a,#116,main92
	lcall klt
main92:	cjne a,#117,main93
	lcall klu
main93:	cjne a,#118,main94
	lcall klv
main94:	cjne a,#119,main95
	lcall klw
main95:	cjne a,#120,main96
	lcall klx
main96:	cjne a,#121,main97
	lcall kly
main97:	cjne a,#122,main98
	lcall klz

main98:	ljmp main


bmin:	push 2		; prijme z planu a posle do PC
	push 3
	mov r2,#8		; v r2 je ta poti bit k pijet
	mov r3,#0		; v r3 je prijimany byte
in1:	jb p2.1,in1		; ekm na nulov p2.1
	clr c
	jnb p2.0,in2		
	setb c
in2:	clr p2.2		; mam prijato, potvrdim mu to
	mov a,r3
	rrc a
	mov r3,a
in3:	jnb p2.1,in3		; ekm na jednikov p2.1		
	setb p2.2
	djnz r2,in1
	mov a,r3		; pijat byte do A
	mov sbuf,a 		; odesilani seriovym kanalem dat A
in4:	jnb ti,in4
	clr ti	
	pop 3
	pop 2
	ret



klz:	mov r7,#255		; nastav citac 
klz1:	jb p3.7,klz1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.2			; nastav sloupec 
klz2:	jb p3.6,klz2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klz1		; to cele 255x
	ret

kls:	mov r7,#255		; nastav citac 
kls1:	jb p3.7,kls1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.3		; nastav sloupec 
kls2:	jb p3.6,kls2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	djnz r7,kls1		; to cele 255x
	ret

klw:	mov r7,#255		; nastav citac 
klw1:	jb p3.7,klw1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.4			; nastav sloupec 
klw2:	jb p3.6,klw2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,klw1		; to cele 255x
	ret

kll:	mov r7,#255		; nastav citac 
kll1:	jb p3.7,kll1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.6			; nastav sloupec 
kll2:	jb p3.6,kll2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	djnz r7,kll1		; to cele 255x
	ret

klo:	mov r7,#255		; nastav citac 
klo1:	jb p3.7,klo1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.7			; nastav sloupec 
klo2:	jb p3.6,klo2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,klo1		; to cele 255x
	ret


klsp:	mov r7,#255		; nastav citac 
klsp1:	jb p3.6,klsp1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.1			; nastav sloupec 
klsp2:	jb p3.5,klsp2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.1		; zrus sloupec 
	djnz r7,klsp1		; to cele 255x
	ret

klc:	mov r7,#255		; nastav citac 
klc1:	jb p3.6,klc1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.2			; nastav sloupec 
klc2:	jb p3.5,klc2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klc1		; to cele 255x
	ret

klf:	mov r7,#255		; nastav citac 
klf1:	jb p3.6,klf1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.3			; nastav sloupec 
klf2:	jb p3.5,klf2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	djnz r7,klf1		; to cele 255x
	ret

klr:	mov r7,#255		; nastav citac 
klr1:	jb p3.6,klr1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.4			; nastav sloupec 
klr2:	jb p3.5,klr2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,klr1		; to cele 255x
	ret

kln:	mov r7,#255		; nastav citac 
kln1:	jb p3.6,kln1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.5			; nastav sloupec 
kln2:	jb p3.5,kln2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.5		; zrus sloupec 
	djnz r7,kln1		; to cele 255x
	ret

klj:	mov r7,#255		; nastav citac 
klj1:	jb p3.6,klj1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.6			; nastav sloupec 
klj2:	jb p3.5,klj2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	djnz r7,klj1		; to cele 255x
	ret

klu:	mov r7,#255		; nastav citac 
klu1:	jb p3.6,klu1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.7			; nastav sloupec 
klu2:	jb p3.5,klu2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,klu1		; to cele 255x
	ret

klv:	mov r7,#255		; nastav citac 
klv1:	jb p3.5,klv1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.2			; nastav sloupec 
klv2:	jb p3.4,klv2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klv1		; to cele 255x
	ret

klg:	mov r7,#255		; nastav citac 
klg1:	jb p3.5,klg1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.3			; nastav sloupec 
klg2:	jb p3.4,klg2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	djnz r7,klg1		; to cele 255x
	ret

klt:	mov r7,#255		; nastav citac 
klt1:	jb p3.5,klt1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.4			; nastav sloupec 
klt2:	jb p3.4,klt2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,klt1		; to cele 255x
	ret

klb:	mov r7,#255		; nastav citac 
klb1:	jb p3.5,klb1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.5			; nastav sloupec 
klb2:	jb p3.4,klb2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.5		; zrus sloupec 
	djnz r7,klb1		; to cele 255x
	ret

klh:	mov r7,#255		; nastav citac 
klh1:	jb p3.5,klh1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.6			; nastav sloupec 
klh2:	jb p3.4,klh2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	djnz r7,klh1		; to cele 255x
	ret

kly:	mov r7,#255		; nastav citac 
kly1:	jb p3.5,kly1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.7			; nastav sloupec 
kly2:	jb p3.4,kly2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,kly1		; to cele 255x
	ret

klx:	mov r7,#255		; nastav citac 
klx1:	jb p3.4,klx1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.2			; nastav sloupec 
klx2:	jb p3.3,klx2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klx1		; to cele 255x
	ret

kld:	mov r7,#255		; nastav citac 
kld1:	jb p3.4,kld1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.3			; nastav sloupec 
kld2:	jb p3.3,kld2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	djnz r7,kld1		; to cele 255x
	ret

kle:	mov r7,#255		; nastav citac 
kle1:	jb p3.4,kle1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.4			; nastav sloupec 
kle2:	jb p3.3,kle2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,kle1		; to cele 255x
	ret

klm:	mov r7,#255		; nastav citac 
klm1:	jb p3.4,klm1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.5			; nastav sloupec 
klm2:	jb p3.3,klm2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.5		; zrus sloupec 
	djnz r7,klm1		; to cele 255x
	ret

klk:	mov r7,#255		; nastav citac 
klk1:	jb p3.4,klk1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.6			; nastav sloupec 
klk2:	jb p3.3,klk2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	djnz r7,klk1		; to cele 255x
	ret

kli:	mov r7,#255		; nastav citac 
kli1:	jb p3.4,kli1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.7			; nastav sloupec 
kli2:	jb p3.3,kli2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,kli1		; to cele 255x
	ret

kla:	mov r7,#255		; nastav citac 
kla1:	jb p3.3,kla1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.3			; nastav sloupec 
kla2:	jb p3.7,kla2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	djnz r7,kla1		; to cele 255x
	ret

klq:	mov r7,#255		; nastav citac 
klq1:	jb p3.3,klq1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.4			; nastav sloupec 
klq2:	jb p3.7,klq2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,klq1		; to cele 255x
	ret

klen:	mov r7,#255		; nastav citac 
klen1:	jb p3.3,klen1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.6			; nastav sloupec 
klen2:	jb p3.7,klen2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	djnz r7,klen1		; to cele 255x
	ret

klp:	mov r7,#255		; nastav citac 
klp1:	jb p3.3,klp1		; cekej az se bude testovat tento radek
	nop			; pauzicka
	cpl p3.2		; blikne cervena dioda
	clr p1.7			; nastav sloupec 
klp2:	jb p3.7,klp2		; cekej, az se bude testovat nizsi radek
	nop			; mala pauza
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,klp1		; to cele 255x
	ret


kl0:	mov r7,#255		; nastav citac 
kl01:	jb p3.4,kl01		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
kl02:	jb p3.3,kl02		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	clr p1.7		; nastav sloupec 
kl0a:	jb p3.7,kl0a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,kl01		; to cele 255x
	ret

kl1:	mov r7,#255		; nastav citac 
kl11:	jb p3.4,kl11		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
kl12:	jb p3.3,kl12		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	clr p1.4		; nastav sloupec 
kl1a:	jb p3.7,kl1a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,kl11		; to cele 255x
	ret

kl2:	mov r7,#255		; nastav citac 
kl21:	jb p3.7,kl21		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.4		; nastav sloupec 
kl22:	jb p3.6,kl22		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
kl2a:	jb p3.4,kl2a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
kl2b:	jb p3.3,kl2b		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	djnz r7,kl21		; to cele 255x
	ret

kl3:	mov r7,#255		; nastav citac 
kl31:	jb p3.4,kl31		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
	clr p1.4
kl32:	jb p3.3,kl32		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	setb p1.4
	djnz r7,kl31		; to cele 255x
	ret

kl4:	mov r7,#255		; nastav citac 
kl41:	jb p3.6,kl41		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.4		; nastav sloupec 
kl42:	jb p3.5,kl42		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
kl4a:	jb p3.4,kl4a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
kl4b:	jb p3.3,kl4b		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	djnz r7,kl41		; to cele 255x
	ret

kl5:	mov r7,#255		; nastav citac 
kl51:	jb p3.5,kl51		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.4		; nastav sloupec 
kl52:	jb p3.4,kl52		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	clr p1.0		; nastav sloupec 
kl5a:	jb p3.3,kl5a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	djnz r7,kl51		; to cele 255x
	ret

kl6:	mov r7,#255		; nastav citac 
kl61:	jb p3.5,kl61		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.7		; nastav sloupec 
kl62:	jb p3.4,kl62		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	clr p1.0		; nastav sloupec 
kl6a:	jb p3.3,kl6a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	djnz r7,kl61		; to cele 255x
	ret


kl7:	mov r7,#255		; nastav citac 
kl71:	jb p3.6,kl71		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.7		; nastav sloupec 
kl72:	jb p3.5,kl72		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
kl7a:	jb p3.4,kl7a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
kl7b:	jb p3.3,kl7b		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	djnz r7,kl71		; to cele 255x
	ret

kl9:	mov r7,#255		; nastav citac 
kl91:	jb p3.7,kl91		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.7		; nastav sloupec 
kl92:	jb p3.6,kl92		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
kl9a:	jb p3.4,kl9a		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
kl9b:	jb p3.3,kl9b		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	djnz r7,kl91		; to cele 255x
	ret



kl8:	mov r7,#255		; nastav citac 
kl81:	jb p3.4,kl81		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.0		; nastav sloupec 
	clr p1.7
kl82:	jb p3.3,kl82		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.0		; zrus sloupec 
	setb p1.7
	djnz r7,kl81		; to cele 255x
	ret



klhv:	mov r7,#255		; nastav citac 
klhv1:	jb p3.3,klhv1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klhv2:	jb p3.7,klhv2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
;	setb p1.2		; zrus sloupec 
;	clr p1.2		; nastav sloupec 
klhva:	jb p3.6,klhva		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klhv1		; to cele 255x
	ret

klpl:	mov r7,#255		; nastav citac 
klpl1:	jb p3.3,klpl1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klpl2:	jb p3.7,klpl2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	clr p1.3		; nastav sloupec 
klpla:	jb p3.6,klpla		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	djnz r7,klpl1		; to cele 255x
	ret

kluv:	mov r7,#255		; nastav citac 
kluv1:	jb p3.3,kluv1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
kluv2:	jb p3.7,kluv2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	clr p1.4		; nastav sloupec 
kluva:	jb p3.6,kluva		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	djnz r7,kluv1		; to cele 255x
	ret

klhzl:	mov r7,#255		; nastav citac 
klhzl1:	jb p3.3,klhzl1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klhzl2:	jb p3.7,klhzl2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	clr p1.6		; nastav sloupec 
klhzla:	jb p3.6,klhzla		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	djnz r7,klhzl1		; to cele 255x
	ret

klkzl:	mov r7,#255		; nastav citac 
klkzl1:	jb p3.3,klkzl1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klkzl2:	jb p3.7,klkzl2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	clr p1.7		; nastav sloupec 
klkzla:	jb p3.6,klkzla		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	djnz r7,klkzl1		; to cele 255x
	ret


kldt:	mov r7,#255		; nastav citac 
kldt1:	jb p3.6,kldt1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
kldt2:	jb p3.5,kldt2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
kldta:	jb p3.3,kldta		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
kldtb:	jb p3.7,kldtb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,kldt1		; to cele 255x
	ret

klst:	mov r7,#255		; nastav citac 
klst1:	jb p3.6,klst1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.3		; nastav sloupec 
klst2:	jb p3.5,klst2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
klsta:	jb p3.3,klsta		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klstb:	jb p3.7,klstb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klst1		; to cele 255x
	ret

kldo:	mov r7,#255		; nastav citac 
kldo1:	jb p3.6,kldo1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.4		; nastav sloupec 
kldo2:	jb p3.5,kldo2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
kldoa:	jb p3.3,kldoa		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
kldob:	jb p3.7,kldob		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,kldo1		; to cele 255x
	ret

klca:	mov r7,#255		; nastav citac 
klca1:	jb p3.6,klca1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.5		; nastav sloupec 
klca2:	jb p3.5,klca2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.5		; zrus sloupec 
klcaa:	jb p3.3,klcaa		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klcab:	jb p3.7,klcab		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klca1		; to cele 255x
	ret

klve:	mov r7,#255		; nastav citac 
klve1:	jb p3.6,klve1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.6		; nastav sloupec 
klve2:	jb p3.5,klve2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
klvea:	jb p3.3,klvea		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klveb:	jb p3.7,klveb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klve1		; to cele 255x
	ret

klap:	mov r7,#255		; nastav citac 
klap1:	jb p3.6,klap1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.7		; nastav sloupec 
klap2:	jb p3.5,klap2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
klapa:	jb p3.3,klapa		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klapb:	jb p3.7,klapb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klap1		; to cele 255x
	ret


klsc:	mov r7,#255		; nastav citac 
klsc1:	jb p3.5,klsc1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klsc2:	jb p3.4,klsc2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
klsca:	jb p3.3,klsca		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klscb:	jb p3.7,klscb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klsc1		; to cele 255x
	ret

klpo:	mov r7,#255		; nastav citac 
klpo1:	jb p3.5,klpo1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.3		; nastav sloupec 
klpo2:	jb p3.4,klpo2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
klpoa:	jb p3.3,klpoa		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klpob:	jb p3.7,klpob		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klpo1		; to cele 255x
	ret

klpr:	mov r7,#255		; nastav citac 
klpr1:	jb p3.5,klpr1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.4		; nastav sloupec 
klpr2:	jb p3.4,klpr2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
klpra:	jb p3.3,klpra		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klprb:	jb p3.7,klprb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klpr1		; to cele 255x
	ret

klot:	mov r7,#255		; nastav citac 
klot1:	jb p3.5,klot1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.5		; nastav sloupec 
klot2:	jb p3.4,klot2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.5		; zrus sloupec 
klota:	jb p3.3,klota		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klotb:	jb p3.7,klotb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klot1		; to cele 255x
	ret

klme:	mov r7,#255		; nastav citac 
klme1:	jb p3.5,klme1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.6		; nastav sloupec 
klme2:	jb p3.4,klme2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
klmea:	jb p3.3,klmea		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klmeb:	jb p3.7,klmeb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klme1		; to cele 255x
	ret

klam:	mov r7,#255		; nastav citac 
klam1:	jb p3.5,klam1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.7		; nastav sloupec 
klam2:	jb p3.4,klam2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
klama:	jb p3.3,klama		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
klamb:	jb p3.7,klamb		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klam1		; to cele 255x
	ret


kllo:	mov r7,#255		; nastav citac 
kllo1:	jb p3.4,kllo1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
kllo2:	jb p3.3,kllo2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
;	setb p1.2		; zrus sloupec 
;	clr p1.2		; nastav sloupec 
klloa:	jb p3.7,klloa		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,kllo1		; to cele 255x
	ret

klro:	mov r7,#255		; nastav citac 
klro1:	jb p3.4,klro1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.3		; nastav sloupec 
klro2:	jb p3.3,klro2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.3		; zrus sloupec 
	clr p1.2		; nastav sloupec 
klroa:	jb p3.7,klroa		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klro1		; to cele 255x
	ret

klkr:	mov r7,#255		; nastav citac 
klkr1:	jb p3.4,klkr1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.4		; nastav sloupec 
klkr2:	jb p3.3,klkr2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.4		; zrus sloupec 
	clr p1.2		; nastav sloupec 
klkra:	jb p3.7,klkra		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klkr1		; to cele 255x
	ret

klte:	mov r7,#255		; nastav citac 
klte1:	jb p3.4,klte1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.5		; nastav sloupec 
klte2:	jb p3.3,klte2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.5		; zrus sloupec 
	clr p1.2		; nastav sloupec 
kltea:	jb p3.7,kltea		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klte1		; to cele 255x
	ret

klhzr:	mov r7,#255		; nastav citac 
klhzr1:	jb p3.4,klhzr1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.6		; nastav sloupec 
klhzr2:	jb p3.3,klhzr2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.6		; zrus sloupec 
	clr p1.2		; nastav sloupec 
klhzra:	jb p3.7,klhzra		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klhzr1		; to cele 255x
	ret

klkzr:	mov r7,#255		; nastav citac 
klkzr1:	jb p3.4,klkzr1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.7		; nastav sloupec 
klkzr2:	jb p3.3,klkzr2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.7		; zrus sloupec 
	clr p1.2		; nastav sloupec 
klkzra:	jb p3.7,klkzra		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	djnz r7,klkzr1		; to cele 255x
	ret



klmi:	mov r7,#255		; nastav citac 
klmi1:	jb p3.3,klmi1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
	clr p1.3
klmi2:	jb p3.7,klmi2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	setb p1.3
	djnz r7,klmi1		; to cele 255x
	ret

klvy:	mov r7,#255		; nastav citac 
klvy1:	jb p3.3,klvy1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
	clr p1.4
klvy2:	jb p3.7,klvy2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	setb p1.4
	djnz r7,klvy1		; to cele 255x
	ret

klza:	mov r7,#255		; nastav citac 
klza1:	jb p3.3,klza1		; cekej az se bude testovat tento radek
	cpl p3.2		; blikne cervena dioda
	clr p1.2		; nastav sloupec 
	clr p1.7
klza2:	jb p3.7,klza2		; cekej, az se bude testovat nizsi radek
	cpl p3.2		; blikne cervena dioda
	setb p1.2		; zrus sloupec 
	setb p1.7
	djnz r7,klza1		; to cele 255x
	ret




;kl_:	mov r7,#255		; nastav citac 
;kl_1:	jb p3._,kl_1		; cekej az se bude testovat tento radek
;	nop			; pauzicka
;	cpl p3.2		; blikne cervena dioda
;	clr p1._			; nastav sloupec 
;kl_2:	jb p3._,kl_2		; cekej, az se bude testovat nizsi radek
;	nop			; mala pauza
;	cpl p3.2		; blikne cervena dioda
;	setb p1._		; zrus sloupec 
;	djnz r7,kl_1		; to cele 255x
;	ret





serial:	jb ri,prijem		; v pripade prijmu jdi na obsluhu
	reti			; v pripade vysilani konec
prijem:	push psw
	push acc
	mov a,sbuf		; prijimany byte do a
	mov 96,a		; uloz byte na adr. 96
	mov 95,#1		; povol zpracovani
	pop acc
	clr ri			; nulovani priznaku preruseni
	pop psw
	reti			; navrat z preruseni



odesli:	mov sbuf,a 		; odesilani seriovym kanalem dat A
odesx1: jnb ti,odesx1
	clr ti	
	ret



delay:	push 0			; pauza asi 4 vteriny
	push 1
	push 2
	mov r0,#0
	mov r1,#0
	mov r2,#2
delay1:	djnz r0,delay1
	djnz r1,delay1
;	djnz r2,delay1
	pop 2
	pop 1
	pop 0
	ret
	






